#!/usr/bin/env node

var ARI_HOST = '127.0.0.1';
var ARI_PORT = '8088';
var API_KEY = 'ariuser'+':'+ '123';
var APP_NAME = 'dialer';
//var BRIDGE_ID = '1000';
//var CHANNEL_ID = '2000';
//var PLAYBACK_ID = '6900';
var CONTEXT = 'users';
var TIMER = '30';
var FORMAT = 'alaw,ulaw';
var MEDIA = 'sound:sh_1';
var SKIPMS = '3000';
var MIN =200;
var MAX =299;


var WebSocket = require('ws');
var WebSocketServer = require('ws').Server;
var request = require('request');
var ws = new WebSocket( 'ws://' + ARI_HOST + ':' + ARI_PORT + '/ari/events?app=' + APP_NAME + '&api_key=' + API_KEY );
var wss;
var moh_chan;


var uid ={};
var rnd ; 
var ep;

var tmp;
var ticket_stasis = []; // объявление массива



class Ticket_Stasis{
	
 constructor(channel_id_b,channel_id_a,channel_name_a,calling_name,calling_number,called_number) { 
 this.bridge_number = channel_id_b - 100; 
 this.channel_id_a  = channel_id_a;
 this.channel_name_a = channel_name_a;
 this.calling_name =  calling_name;
 this.calling_number = calling_number
 this.channel_id_b = channel_id_b;
 this.called_number = called_number;
 this.playback_channel_id_a = channel_id_b + 400;
 this.playback_channel_id_b = channel_id_b + 700;
 this.ring_to_a =0;
 this.ring_to_b =0;
 this.hangup_from_a = true; // OFF
 this.hangup_from_b = true; // OFF 



 }

// геттер
/*
  get fullName() {
    return `${this.firstName} ${this.lastName}`;
  }
    // сеттер
  set fullName(newValue) {
    [this.firstName, this.lastName] = newValue.split(' ');
  }

  // вычисляемое название метода
  ["test".toUpperCase()]() {
    alert("PASSED!");
  }
 */ 
 get ui()   {    return `${this.bridge_number}`;  }
 get ch_a() {    return `${this.channel_id_a}`;  }
 get ch_b() {    return `${this.channel_id_b}`;  }
 get playback_ch_a() {    return `${this.playback_channel_id_a}`;  }
 get playback_ch_b() {    return `${this.playback_channel_id_b}`;  }
 get cdn () {    return `${this.called_number}`;  }

 get ring_status_a () {    return `${this.ring_to_a}`;  }
 get ring_status_b () {    return `${this.ring_to_b}`;  }
 get hangup_status_a () {    return `${this.hangup_from_a}`;  }
 get hangup_status_b () {    return `${this.hangup_from_b}`;  }
 


 set ch_a(v) { this.channel_id_a = v; }
 set ch_b(v) { this.channel_id_b = v; }
 set ring_status_a (v) {    this.ring_to_a = v; }
 set ring_status_b (v) {    this.ring_to_b = v; }
 set hangup_status_a (v) {  this.hangup_from_a = v; }
 set hangup_status_b (v) {  this.hangup_from_b = v; }


}


// обработчик входящих сообщений
ws.onmessage = function(event) {
  var incomingMessage = event.data;
  var str = JSON.parse(event.data);
  var ep;
  
 
//console.log(incomingMessage);
switch(str.type)
{
	
	
	case "StasisStart": 
	console.log('Stasis  start - Dialer');
	if(str.channel.dialplan.exten == ""){break;}
	
rnd = get_uid();
	
ticket_stasis[rnd] = new Ticket_Stasis(rnd,str.channel.id,str.channel.name,str.channel.caller.name,str.channel.caller.number,str.channel.dialplan.exten);
//	show_ticket(rnd);
	

///////// Test Play
if(str.channel.dialplan.exten == "123" ){
ticket_stasis.forEach(function(item, index, array) {
if(ticket_stasis[index].ch_b != ""){ 
play_to_ch(ticket_stasis[index].ch_b,ticket_stasis[index].playback_ch_b,MEDIA,SKIPMS);
return 0;//break; 
} 
});		break;}

if(str.channel.dialplan.exten == "444" ){
ticket_stasis.forEach(function(item, index, array) {
if(ticket_stasis[index].playback_ch_b != ""){ 
del_play_to_ch(ticket_stasis[index].playback_ch_b);
return 0;//break; 
} 
});		break;}
//////////////////////////////test play///////////
		
		
//console.log("+++++++++++++++", rnd );	
	  plus_bridge(ticket_stasis[rnd].ui); 
	  plus_ch_to_bridge(ticket_stasis[rnd].ui,str.channel.id);
	// get_endpoint(str.channel.dialplan.exten);
	 go_to_endpoint("",str.channel.dialplan.exten,ticket_stasis[rnd].ch_b); 
	  //create_new_ch(ep,CONTEXT,APP_NAME,TIMER,ticket_stasis[rnd].ch_b,FORMAT);
	 // create_new_ch(ep,'',APP_NAME,TIMER,ticket_stasis[rnd].ch_b,FORMAT);
	
	   break;
	
	case "Dial":
if(str.dialstatus == 'RINGING'){ring_to_ch(ticket_stasis[str.peer.id].ch_a);break;}


if(str.dialstatus == 'ANSWER'){ 
plus_ch_to_bridge(ticket_stasis[str.peer.id].ui,ticket_stasis[str.peer.id].ch_b); 
del_ring_to_ch(ticket_stasis[str.peer.id].ch_a);
	
	break;}
	
if(str.dialstatus == 'BUSY'){
	
del_ring_to_ch(ticket_stasis[str.peer.id].ch_a);
minus_ch(ticket_stasis[str.peer.id].ch_a,'busy'); 
minus_bridge (ticket_stasis[str.peer.id].ui);
 delete ticket_stasis[str.peer.id];

}
	break;

	case "ChannelEnteredBridge":  
  
    break;
	
	
	case "ChannelConnectedLine": 
	
		
	break;
	


    case "ChannelHangupRequest":
ticket_stasis.forEach(function(item, index, array) {
if(ticket_stasis[index].ch_a == str.channel.id){
minus_ch(ticket_stasis[index].ch_b,'normal');
minus_bridge (ticket_stasis[index].ui);
delete ticket_stasis[index];
return;
}

if(ticket_stasis[index].ch_b == str.channel.id){
minus_ch(ticket_stasis[index].ch_a,'normal');
minus_bridge (ticket_stasis[index].ui);
delete ticket_stasis[index];
return;
}

})

	break;

	case	"ChannelLeftBridge":

       break;	     
		 
	case "ChannelDestroyed":
		
	
		
	break;
	
	  case "StasisEnd":  
	  
	  
//	if(str.channel.caller.number == "1701" ){break;} 
//$('#' + ticket_stasis[index].ui).remove();
	
	   break;

    

    default:            // 


/*
    let k=0; 
ticket_stasis.forEach(function(item, index, array) {
k=k+1;
 
});
    
console.log('=====================COUNT ELEMENT of ARRAY ===',k);
*/

}
};





///////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////



function show_ticket(chid){
	
	var fieldset = document.createElement('fieldset');
	//alert(ticket_stasis[rnd].ui.toString());
	//fieldset.value=ticket_stasis[rnd].ui.toString();
	fieldset.setAttribute( "id", ticket_stasis[chid].ui);
    fieldset.setAttribute( "class", "field_set");
	var legend = document.createElement('LEGEND');
	var txt_legend = document.createTextNode(ticket_stasis[chid].ui);
    legend.setAttribute( "id", ticket_stasis[chid].ui);
	legend.setAttribute( "name", ticket_stasis[chid].cdn);
    legend.setAttribute( "class", "title");
	legend.appendChild(txt_legend);
	//document.getElementById(ticket_stasis[rnd].ui).appendChild(legend);
	fieldset.appendChild(legend);
	document.getElementById('monitor').appendChild(fieldset);
	
	
}





function get_uid(){
 var rnd2 = Math.floor(MIN + Math.random()*(MAX + 1 - MIN));

//console.log("LEN ticket array: ",ticket_stasis.length);
let cnt = 0;
let i =45;
while(i){
 
ticket_stasis.forEach((element, index, array) => {
if(ticket_stasis[index].ch_b == rnd2){cnt = cnt + 1;}

//cnt = cnt + 1;  

})

if(cnt == 0 ){rnd=rnd2; i=0;}
else{cnt=0;rnd2 = Math.floor(MIN + Math.random()*(MAX + 1 - MIN));}
}


//console.log("unicum == ",rnd );
rnd = rnd2;
return rnd2;
};




function create_new_ch(e, cntxt, apps, t=30, ch_id, frmt='alaw%2Culaw'){


//create channel
var sts;
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
if(cntxt == ""){ url = url + '/ari/channels?endpoint=' + e; }
else{url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt; }
url = url + '&app=' + apps + '&timeout=' + t + '&channelId=' + ch_id;
url = url + '&formats=' + frmt;

//console.log(url);

request.post(
                url,
	    {
		form: {
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if (!error &&  response.statusCode != 204) {
        	console.log( 'Create channel Response Code:', response.statusCode );
    		console.log( 'Create channel: ', ch_id );
    		}
	//	moh_manage( data );
	    }
	);


  
  
};
        	


function go_to_endpoint(cntxt,exten,ch_id){
request.get(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/endpoints',
    {	form: { 'api_key': API_KEY, }	    },
	    function (error, response, b) {
            var p = {};
            var e;
	    console.log('Get endpoint Response code: ', response.statusCode );
	    
    		if ( !error &&  response.statusCode == 200) {
//console.log(response.body);
//    	p=JSON.parse(response.text);
    	p=JSON.parse(response.body);
//    			console.log(p);
	for( i=0; i < p.length; ++i){
			
		if(p[i].resource == exten){ 
        	  
	if(p[i].state == "online" ||  p[i].state == "unknown"){
 
                    e = p[i].technology + '/' + p[i].resource;
                       console.log('Get endpoint:',  e);



var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
if(cntxt == ""){ url = url + '/ari/channels?endpoint=' + e; }
else{url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt; }
url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
url = url + '&formats=' + FORMAT;

//console.log(url);

request.post(

                url,
	    {
		form: {
		    'api_key': API_KEY,
		}
	    },
	    
	        function (error, response, body) {
    		//var tmp = JSON.parse(body);
    		//console.log(tmp);
    		if (!error) {
    		//if (!error  &&  response.statusCode != 204) {
//	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'Create channel Response code:', response.statusCode );
    		console.log( 'Create channel: ', ch_id );
    		}
	//	moh_manage( data );
	    }
	    
	);

 			          }
		     }
			                   }

    		}
	//	moh_manage( data );
	    }
	);
};





function  minus_ch (ch,cause){


request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch,
		{
		    form: {
		    reason:cause,
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error) {
			//    if (!error && response.statusCode != 204) {
//		console.log( ' WS on message: ', body, ': ', response.statusCode );	
				console.log('Delete channel Response code: ', response.statusCode);
				console.log('Delete channel : ', ch);
				//console.log('Delete channel Response : ', response.statusCode);
			    }
		}
	    );
 
// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' +  ch + '?api_key=' + API_KEY;

};



function  plus_bridge (brd){
//console.log('plus bridge');
request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd,
	    {
		form: {
		type: 'mixing',
		name: brd,
         	'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if ( !error) {
    	//	if ( !error && response.statusCode == 200) {	
//        	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'Create Bridge  Response code: ',':', response.statusCode );
    		console.log( 'Create Bridge: ', brd);
    		}
	//	moh_manage( data );
	    }
	);

};

function  minus_bridge (brd){

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error) {
			    //if (!error && response.statusCode != 204) {
			
//		console.log( ' WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete Bridge Response code: ', response.statusCode);
				console.log('Delete Bridge : ', brd);
				
			    }
		}
	    );


 
// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' +  b + '?api_key=' + API_KEY;

};
	

function  plus_ch_to_bridge (brd, ch){


request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd + '/addChannel?channel=' + ch,
	    {
		form: {
//		     channel: ch,
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
	        if (!error) {
    		//if (!error &&  response.statusCode != 200) {
//        	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'Add channel to Bridge Response code: ', response.statusCode );
    		console.log( 'Add channel: ', ch, 'To' , brd)
    		}
	//	moh_manage( data );
	    }
	); 

};



function  minus_ch_from_bridge (brd, ch){

// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges?bridgeId=' + BRIDGE_ID + '&api_key=' + API_KEY;
// http://192.168.88.25:8088/ari/bridges/1451451451/addChannel?channel=ХХХ_IN_ХХХХХ.ХХХ&api_key=ariuser:123
//http://192.168.88.25:8088/ari/bridges/1451451451/removeChannel?channel=1571734363.523&api_key=ariuser:123


request.del(
 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd + '/removeChannel?channel=' + ch,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error) {
			    //if (!error && response.statusCode != 204) {
//		console.log( ' WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete channel from Bridge  Response code : ', response.statusCode);
				console.log('Delete channel:', ch, ' from Bridge : ', brd);
				
			    }
		}
	    );


// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + b + '/removeChannel?channel=' + ch + '&api_key=' + API_KEY;

    
};


function play_control(ch_play,operation){
//http://192.168.88.25:8088/ari/playbacks/6484121a-4b78-4851-9086-52c6dfac04a5/control?operation=reverse&api_key=ariuser:123

var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/playbacks/' + ch_play + 'control?operation=' + operation + '&api_key=' + API_KEY;
var p,sts;
/**/   
  var params = {}

var r = fetch(url, {
    method : "POST",
	headers: {  
      "Content-type": "application/json;"  
    },  
    body: JSON.stringify(params),
  
}).then(function(response) {
   return response.json();
  })
  .then(function(json) {
 })
  .catch(function(error) {
    log('Request failed', error)
  });


};

function play_to_ch(ch_id,ch_play,media, skipms=3000){
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels/' + ch_id + '/play/' + ch_play + '?media=' + media + '&skipms=' + skipms; 

request.post(
//    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
               url,
	    {
		form: {
 
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, b) {
    		if ( response.statusCode != 200) {
        //    	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );
                               	console.log('PLay to channel Response code : ', response.statusCode);
                               	console.log('PLay', media, ' to :' , ch_id);
				
        
    		}
	//	moh_manage( data );
	    }
	);
//http://192.168.88.25:8088/ari/channels/1000000000/play/6960000000?media=sound%3Apaul_m&skipms=3000&api_key=ariuser:123 

  
};
        	
function del_play_to_ch(ch_id){
//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/playbacks/' + ch_id ,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error && response.statusCode != 204) {
		
	//	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete PLayback Response code : ', response.statusCode);
				console.log('Delete PLayback : ', ch_id);
				
			    }
		}
	    );

  
};





function ring_to_ch(ch_id){
request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
	    {
		form: {
 
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, b) {
    		if ( response.statusCode != 200) {
            //	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );
                               	
                               	console.log('RING Response code: ', response.statusCode);
                               	console.log('RING to channel: ', ch_id);
				
        
    		}
	//	moh_manage( data );
	    }
	);


//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123
  
};


function del_ring_to_ch(ch_id){
//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error && response.statusCode != 204) {
		
	//	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete RING Response code : ', response.statusCode);
				console.log('Delete RING : ', ch_id);
				
			    }
		}
	    );

  
};




